//adc.c
#include "adc.h"
#include "lcd.h"
#include "stdio.h"

char res[30];

// Init ADC
void InitADC()
{

  ADCON0_bit.ADSNM = 0x0;     //ch0->ch1->ch2->ch3
  ADCON0_bit.SCNC = 0x0;      //Cycle back to first channel after one cycle through the specified channels


  ADCON1_bit.ADSTM = 0x0;     //set chanel 1
  ADCON0_bit.ADRUN = 0x1;     //Start analog-to-digital converter
  ADCON1_bit.STS = 0x1;       //start ADC

//  ADCON2_bit.ACKSEL = 0x1;    //CCLK/2

}

// get velue from chanel 1
unsigned int GetADCValue1()
{
  while(!ADINT_bit.INTSN);
  ADINT_bit.INTSN=1;
  return (unsigned int) ADR0/*_bit.DT0*/;
}

// get velue from chanel 2
unsigned int GetADCValue2()
{
  while(!ADINT_bit.INTSN);
  ADINT_bit.INTSN=1;
  return (unsigned int) ADR1/*_bit.DT1*/;
}

// get velue from chanel 3
unsigned int GetADCValue3()
{
  while(!ADINT_bit.INTSN);
 ADINT_bit.INTSN=1;
  return (unsigned int) ADR2;
}

// get velue from chanel 4
unsigned int GetADCValue4()
{
  while(!ADINT_bit.INTSN);
  ADINT_bit.INTSN=1;
  return (unsigned int) ADR3;
}


// calculate and print Temp value
void CalcTemp(unsigned int t) {

  float T;
  T = (float)t/21;
  sprintf((char *)res,"Temp %0.1f C",T);

  //print
  LCDSendCommand(CLR_DISP);     // LCD clear
  LCDSendCommand(DD_RAM_ADDR);  // Set first row
  LCDSendTxt(res);              // Write to LCD
}

// calculate and print Volt value
void CalcVolt(unsigned int v) {

  float V;
  V = (float)v * 3.3/(1024);
  sprintf((char *)res,"Volt %0.2f V",V);

  //print
  LCDSendCommand(DD_RAM_ADDR2); // Set second row
  LCDSendTxt(res);              // Write to LCD

}

